with Ada.Text_Io, Ada.Numerics.Discrete_Random;
use Ada.Text_Io;

procedure Hazaut is 

   type Lehetosegek is ( V_12, B_96, Taxi ); -- a megllk tipusa
   Vege: Boolean := True;
   

    task type Megallo( Id: Lehetosegek ) is
        entry Jarmure_Szallas;
    end Megallo;


    task body Megallo is	
        subtype Kovetesi_Ido is Natural range 3..10;
        package Veletlen is new Ada.Numerics.Discrete_Random(Kovetesi_Ido);
        use Veletlen;
      G: Generator;
    
        
    begin
        Reset(G);
        --for I in 1..Jarmuvek_Szama 
        while Vege = True loop
         delay Random(G) * 0.1;
         
            select
               accept Jarmure_Szallas do
               Put_Line(Lehetosegek'Image(Id)&": Felszallt valaki.");
               Vege := False;
               end;

            else
               
             Put_Line(Lehetosegek'Image(Id)&": Uresen ment el.");
            
            end select;
        end loop;
   end Megallo;
   
   

   type Megallo_Ptr is access Megallo;
   
   

   -- 3 taszkot teszunk a megllkat szimull tombbe, mert 3 megll lesz
   
    Ujpestrol_Rakospalotara: array (Lehetosegek) of Megallo_Ptr :=
     (new Megallo(V_12), new Megallo(B_96), new Megallo(Taxi));
   

    task Pasi;

    task body Pasi is
        package Jarmu_Veletlen is new Ada.Numerics.Discrete_Random(Lehetosegek);
        use Jarmu_Veletlen;
        Jarmu_G: Jarmu_Veletlen.Generator;

        subtype Alldogalas is Positive range 1..4;
        package Ido_Veletlen is new Ada.Numerics.Discrete_Random(Alldogalas);
        use Ido_Veletlen;
        Ido_G: Ido_Veletlen.Generator;

        Merre: Lehetosegek;
    begin
        Reset(Jarmu_G);
        Reset(Ido_G);
        loop
         Merre := Random(Jarmu_G);
         Put_Line("Megyek ehhez:"&Lehetosegek'Image(Merre));
         
         delay 3*0.1;
         
         Put_Line("Odaertem ehhez:"&Lehetosegek'Image(Merre));
         
           select
               Ujpestrol_Rakospalotara(Merre).Jarmure_Szallas;
               exit;
           or
               delay Random(Ido_G) * 0.1;
           end select;
        end loop;
    end Pasi;
   
   

begin
    null;
end Hazaut;
