with Ada.Text_IO, Ada.Numerics.Discrete_Random;
use Ada.Text_IO;

procedure Parcella_Random is

   subtype Parcella is Integer range 1..50;

   package Parcella_Randomos is new Ada.Numerics.Discrete_Random(Parcella);
   use Parcella_Randomos;

    protected Osztott_Generator is
       procedure Reset; -- ezt az eljrst vdjk le
       entry Random( P: out Parcella );
    private
       G: Generator;
       Inicializlva: Boolean := False;
    end;

    protected body Osztott_Generator is
       procedure Reset is begin Reset(G); Inicializlva := True; end; -- ezt az eljrst vdjk le
       entry Random( P: out Parcella ) when Inicializlva is
         begin P := Random(G); end;
   end;

   Hely: Parcella;

Begin
   Osztott_Generator.Reset;
   Osztott_Generator.Random(Hely);
   Put_Line(Parcella'Image(Hely));
End;
